import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;
import ddf.minim.signals.*;
import ddf.minim.spi.*;
import ddf.minim.ugens.*;
import javax.swing.JFrame;
import java.awt.Dimension;
import java.awt.Image;
import java.util.List;
import controlP5.*;
//import processing.awt.PSurfaceAWT;

ControlP5 cp5;
String textValue = "";

int NZones = 6;
int Nz = NZones + 2;	//	+total, highspeed,
int Ngrp=30;		// Number of Groups
int grp = 0;		// current grp (grp-th start)
boolean isStopCounting=false;
int stopTime=0;
int restartTime=0;
boolean isChanged = false;
String saveMessage = "";
String loadMessage = "";

//
// Browsing Frame
//
class BrowsingFrame extends PApplet {
  PApplet parent;
  int grp3=0;
  
  BrowsingFrame(PApplet _parent) {
    super();
    parent = _parent;
    PSurface surface = super.initSurface();
    surface.placeWindow(new int[]{0,0}, new int[]{0,0});
    this.showSurface();
    this.startSurface();
  }
  
  void settings() {
    size(640,400);
  }
  
  void setup() {
    surface.setSize(640,400);
  }

int Y0 = 32;
int DY = 32;
  
  void draw() {	// Browsing Frame
    int ms = parent.millis();
    background(0,128,0);

    if (grp3>=Ngrp) {
      return;
    }
    if (grp3<0) {
      return;
    }

    textSize(24);
    textAlign(LEFT);
    fill(0,255,0);

    text("#"+(grp3+1),40,Y0);
    text("Group "+records[grp3].group,100,Y0);

    fill(0,64,0);
    for (int i=0; i<Nz; i++) {
      textAlign(LEFT);
      int msec,sec,zs;
      int ac = records[grp3].getAchieve(i);

      // print Time
      if (ac<0) {		// not yet started
         fill(0,64,0);
      } else if (ac==0) {	// running
         fill(0,255,0);
      } else if (ac==1) {	// complete (going to the next)
         fill(0,192,0);
      } else if (ac==2) {	// got to the next
         fill(0,192,0);
      } else if (ac==3) {	// off the track
         fill(0,0,128);
      } else if (ac==4) {	// retired
         fill(128,0,0);
      }
      if (i==0) {
        text("Total:",40,(i+1)*DY+Y0);
      } else if (i<=3) {
        text("Zone "+i,40,(i+1)*DY+Y0);
      } else if (i==4) {
        text("Speed:",40,(i+1)*DY+Y0);
      } else {
        text("Zone "+(i-1),40,(i+1)*DY+Y0);
      }
    
      textAlign(RIGHT);
      if (grp3==grp) {
        msec = records[grp3].getTime1(i,ms);
      } else {
        msec = records[grp3].zone_finish[i]-records[grp3].zone_start[i]-records[grp3].stopInterval1[i];
      }
      sec = msec/1000;
      zs = (msec - sec*1000)/100;
      if (i>0) {
        if (ac==0) {
        	if (sec>=time1) {
            fill(255,0,0);
  	} else {
            fill(0,255,0);
  	}
        } else if (ac>0) {
        	if (sec>=time1) {
            fill(192,0,0);
  	} else {
            fill(0,192,0);
  	}
        }
      }
      text(""+sec+"."+zs,240,(i+1)*DY+Y0);
      if (i>0) {
        if (grp3==grp) {
          msec = records[grp3].getTime2(i,ms);
        } else {
          msec = records[grp3].got_to_next[i]-records[grp3].zone_start[i]-records[grp3].stopInterval2[i];
        }
        sec = msec/1000;
        zs = (msec - sec*1000)/100;
        if ((ac>=0)&&(ac<=1)) {	// running or going to the next
          if (sec>=time2) {
            fill(255,0,0);
          } else {
            fill(0,255,0);
          }
        }
        if (ac>1) {		// got to the next
          if (sec>=time2) {
            fill(192,0,0);
          } else {
            fill(0,192,0);
          }
        }
        text(""+sec+"."+zs,400,(i+1)*DY+Y0);
      }
    }
    textAlign(LEFT);
    text("j:next  k:prev",80,(Nz+2)*DY+Y0);
  }

  void keyPressed() {	// BrowsingFrame
    if (key == 'j') {
    	if (grp3<Ngrp-1) {
		grp3++;
	}
    } else if (key == 'k') {
    	if (grp3>0) {
		grp3--;
	}
    }
  }

  void close() {
	surface.setVisible(false);
  }
  void exit() {
  	ConfirmExit();
  }
}

//
// Controle Frame
//
class ControlFrame extends PApplet {
  PApplet parent;
  String mymessage="";
  
  ControlFrame(PApplet _parent) {
    super();
    parent = _parent;
    PSurface surface = super.initSurface();
    surface.placeWindow(new int[]{0,0}, new int[]{0,0});
    this.showSurface();
    this.startSurface();
  }
  
  void settings() {
    size(800,600);
  }
  
int Y0 = 40;
int DY = 60;

  void setup() {
    surface.setSize(800,600);
    cp5 = new ControlP5(this);
    cp5.addTextfield("group")
      .setPosition(280,Y0+DY-32)
      .setSize(100,40)
      .setFont(createFont("ariel",32));
  }

  public void next(int theValue) {
  	if (grp<Ngrp) {
		if (records[grp].getAchieve(0)>0) {
			grp++;
		} else {
  			records[grp].returnPressed();
		}
	}
  }

  // ControlFrame draw()
  void draw() {
    background(0,128,0);
   /*
    translate(width/2,height/2);
    */
    stroke(0,255,0);
    fill(0,128,0);
    
    textSize(32);

	int i=0;

	// Group
	textAlign(LEFT);
	fill(0,255,0);
	stroke(0,128,0);
	textValue = cp5.get(Textfield.class,"group").getText();
	int grpnum = int(textValue);
	if ((grpnum>0)&&(grpnum<=Ngrp)) {
		records[grp].group = grpnum;
	}
	text("#"+(grp+1),100,Y0+i*DY);
	text("Group "+records[grp].group,160,Y0+i*DY);
	i++;
	text("Group:",100,Y0+i*DY);
	i++;
	// NextState
	int zn = records[grp].getZone();
	int ac = records[grp].getAchieve(zn%Nz);
	String s = "";
	if (zn<0) {
		s += "Start";
	} else if (zn==0) {
		s += "--> Zone 1";
	} else if ((zn==3)&&(ac>0)) {
		s += "--> High Speed Zone";
	} else if ((zn==4)&&(ac==0)) {
		s += "High Speed Zone -->";
	} else if ((zn==Nz-1)&&(ac>0)) {
		s += "Goal";
	} else if (zn==Nz) {
		s += "Next Group";
	} else {
		if (zn >= 4) {
			zn--;
		}
		if (ac==0) {
			s += "Zone "+zn + " -->";
		} else {
			s += "--> Zone "+(zn+1);
		}
	}
	text("ENTER",100,Y0+i*DY);
	fill(192,0,192);
	stroke(255,255,255);
	text("to "+s,280,Y0+i*DY);
	i++;
	fill(0,255,0);
	stroke(0,128,0);
	text("  o  ",100,Y0+i*DY); text("to Off the track",280,Y0+i*DY);
	i++;
	text("  r  ",100,Y0+i*DY); text("to Retire",280,Y0+i*DY);
	i++;
	if (isStopCounting) {
		s = "Restart";
	} else {
		s = "Stop";
	}
	text("SPACE",100,Y0+i*DY); text("to "+s,280,Y0+i*DY);
	i++;
	text("  s  ",100,Y0+i*DY); text("to Save",280,Y0+i*DY);
	i++;
	text("  l  ",100,Y0+i*DY); text("to Load",280,Y0+i*DY);
	i++;
	text("ESC",100,Y0+i*DY); text("to Exit",280,Y0+i*DY);
	i++;
	textSize(16);
	fill(0);
	if (isChanged) {
		loadMessage = "";
		saveMessage = "";
	}
	text("don't press ENTER",400,Y0+1*DY);
	text("never use",400,Y0+5*DY);
	text(saveMessage,400,Y0+6*DY);
	text(loadMessage,400,Y0+7*DY);
  }
  
  void mouseClicked() {
    parent.mouseClicked();
  }
  
  void mouseDragged() {
    parent.mouseDragged();
  }
  
  void mouseMoved() {
    parent.mouseMoved();
  }
  
  void mousePressed() {
    parent.mousePressed();
  }
  
  void mouseWheel(MouseEvent event) {
    parent.mouseWheel(event);
  }
  
  void keyPressed() {	// ControlFrame
    if (key == ESC) {
      key = 0;
      exit();
    } else if (key == ENTER) {
      next(0);
    } else if ((key=='o')||(key=='O')) {
      records[grp].offtheTrack();
    } else if ((key=='r')||(key=='R')) {
      records[grp].retire();
    } else if (key == ' ') {
      records[grp].toggleStop();
    } else if ((key == 's')||(key == 'S')) {
      saveRecords();
    } else if ((key == 'l')||(key == 'L')) {
      loadRecords();
    } else if (key == DELETE) {
      mymessage = "delete";
    } else if (key == BACKSPACE) {
      mymessage = "backspace";
    } else {
      mymessage = ""+key;
    }
  }
  void keyReleased() {
    parent.keyReleased();
  }
  
  void keyTyped() {
    parent.keyTyped();
  }

  void close() {
	surface.setVisible(false);
  }

  void exit() {
    ConfirmExit();
  }
}
//
//	End of ControlFrame
//


//
//	Record
//
class Record {
	int group=-1;		//	1,...,30
	int[] achieve = new int[Nz];
			// -1: not yet started, 0:running: 1:complete(going to the next),
			//  2:got to the next, 3:off the track, 4:retired
	int[] zone_start = new int[Nz];
	int[] zone_finish = new int[Nz];
	int[] got_to_next = new int[Nz];
	int[] stopInterval1 = new int[Nz];
	int[] stopInterval2 = new int[Nz];

	Record() {
		for (int i=0; i<Nz; i++) {
			zone_start[i] = -1;
			zone_finish[i] = -1;
			got_to_next[i] = -1;
			stopInterval1[i] = 0;
			stopInterval2[i] = 0;
			achieve[i] = -1;
		}
	}

	void setGroup(int _grp) {
		group = _grp;
	}

	void returnPressed() {
		int msec = millis();
		if (isStopCounting) {
			toggleStop();
		}
		int zn = getZone();
		int ac = getAchieve(zn);
		if (zn>=Nz) {	// competition is over. do nothing
			return;
		}
		isChanged = true;
		if (zn<0) {			// not yet started. START!
			zone_start[0] = msec;
			achieve[0] = 0;	// running
			return;
		}
		if (zn==0) {// start Zone 1
			zone_start[zn+1] = msec;
			achieve[zn+1] = 0;	// running
			return;
		}
		if ((zn==Nz-1) && (ac==1)) {	// GOAL!!!
			zone_finish[0] = msec;
			got_to_next[0] = msec;
			got_to_next[zn] = msec;
			achieve[0] = 1;			// Goal!!
			achieve[zn] = 2;		// got to the next
			got_to_next[zn] = msec;
		}
		if (ac == 0) {				// finish the Zone (going to the next)
			zone_finish[zn] = msec;
			achieve[zn] = 1;
		} else if ((zn<Nz-1)&&(ac<2)) {
			achieve[zn] = 2;		// got to the next
			got_to_next[zn] = msec;
			zone_start[zn+1] = msec;	// start the Zone
			achieve[zn+1] = 0;		// running
		} else if (zn<Nz-1) {			// if already retired or off the track
			zone_start[zn+1] = msec;	// just start the Zone
			achieve[zn+1] = 0;		// running
		}
	}
	void courseOut(int m) {
		int msec = millis();
		isChanged = true;
		int zn = getZone();
		int ac = getAchieve(zn);
		if ((zn<0)||(zn>=Nz)) {
			return;
		}
		if ((zn>0)&&(ac==0)) {
			achieve[zn] = m;
			zone_finish[zn] = msec;
			got_to_next[zn] = msec;
		} else if ((zn>0)&&(ac>0)) {
			achieve[zn] = m;
			got_to_next[zn] = msec;
		}
		if (zn==Nz-1) {
			zone_finish[0] = msec;
			achieve[0] = m;
		}
		if ((zn==0)&&(ac==0)) {
			got_to_next[0] = msec;
		}
	}
	void offtheTrack() {
		courseOut(3);
	}
	void retire() {
		courseOut(4);
	}
	void toggleStop() {
		int msec = millis();
		isChanged = true;
		if (isStopCounting==false) {	// Stop
			isStopCounting = true;
			stopTime = msec;
		} else {			// Restart
			isStopCounting = false;
			int stopInt = msec - stopTime;
			int zn = getZone();
			int ac = getAchieve(zn);

			if ((zn>0)&&(zn<Nz)) {
				stopInterval1[0] += stopInt;
				stopInterval2[0] += stopInt;
				stopInterval2[zn] += stopInt;
				if (ac==0) {
					stopInterval1[zn] += stopInt;
				}
			}
			if (zn==0) {
				stopInterval1[0] += stopInt;
				stopInterval2[0] += stopInt;
			}
		}
	}

	int getTime1(int zone, int msec) {
		int stopInt=stopInterval1[zone];
		int zn = getZone();
		int ac = getAchieve(zn);
		if ((isStopCounting)&&(zone==zn)&&(ac==0)) {
			stopInt += msec-stopTime;
		} else if ((isStopCounting)&&(zone==0)&&((ac==0)||(ac==1))) {
			stopInt += msec-stopTime;
		}
		if (achieve[zone]<0) {
			return -1;
		}
		if (achieve[zone]==0) {
			return msec - zone_start[zone]-stopInt;
		}
		if ((zone==0)&&(achieve[Nz-1]<2)) {
			return msec - zone_start[zone]-stopInt;
		}
		return zone_finish[zone]-zone_start[zone]-stopInt;
	}

	int getTime2(int zone, int msec) {
		int stopInt=stopInterval2[zone];
		int zn = getZone();
		if ((isStopCounting)&&((zone==zn)||(zone==0))) {
			stopInt += msec-stopTime;
		}
		if (achieve[zone]<0) {			// not yet started
			return -1;
		}
		if ((achieve[zone]==0)||(achieve[zone]==1)) {	// running or going to next
			return msec - zone_start[zone]-stopInt;
		}
		return got_to_next[zone]-zone_start[zone]-stopInt;
	}
	int getAchieve(int zone) {
		if (zone>=0) {
			return achieve[zone%Nz];
		}
		return -1;
	}
	int getZone() {
		if (achieve[0]<0) {
			return -1;
		}
		for (int i=0; i<Nz-1; i++)  {
			if ((achieve[i]>=0)&&(achieve[i+1]<0)) {
				return i;
			}
		}
		if ((achieve[Nz-1]>=0)&&(achieve[0]==0)) {
			return Nz-1;
		}
		return Nz;
	}
}
//
//	End of Record
//

//
//	Main Frame (Full Screen)
//	1920 x 1080 expected

ControlFrame secondFrame;
BrowsingFrame thirdFrame;

Minim minim;
AudioPlayer bell1,bell2,bell3;
int timeBell1=-1, timeBell2=-1, timeBell3=-1;
String timeStr="";
String mymessage = "";

void ConfirmExit() {
  int exitChoice = javax.swing.JOptionPane.showConfirmDialog(frame,
    "Are you sure to exit?", "ZoneTimer - Exit Confirmation", javax.swing.JOptionPane.YES_NO_OPTION);
  if (exitChoice == javax.swing.JOptionPane.YES_OPTION) {
    super.exit();
  } else {
    secondFrame.close();
    secondFrame = new ControlFrame(this);
    thirdFrame.close();
    thirdFrame = new BrowsingFrame(this);
  }
}

void exit() {	// Main
  ConfirmExit();
}

void stop() {
  bell1.close();
  bell2.close();
  bell3.close();
  minim.stop();
  super.stop();
}

void settings() {
//  size(1920,1080);
  fullScreen();
}

Record[] records;
int time1,time2,time3;

void setup() {	// Main
//  surface.setSize(1920,1080);
//  fullScreen(P2D);
  fullScreen(2);
  minim = new Minim(this);
  bell1 = minim.loadFile("bell1.wav");
  bell2 = minim.loadFile("bell2.wav");
  bell3 = minim.loadFile("bell3.wav");
  time1 = 20;	//20 sec
  time2 = 35;	//35 sec
  time3 = 240;	//240 sec
  Ngrp = 30;
  grp = 0;
  records = new Record[Ngrp];
  for (int i=0; i<Ngrp; i++) {
  	records[i] = new Record();
  	records[i].setGroup(i+1);
  }

  smooth();
  frameRate(30);
  secondFrame = new ControlFrame(this);
  thirdFrame = new BrowsingFrame(this);
}

int ss;
int mm;
int hh;

void drawClock() {
  int ms = millis();
  float s = second();
  float m = minute() + (s/60.0);
  float h = hour() % 12 + (m/60.0);
  
  ss = (int)s;
  mm = (int)m;
  hh = (int)h;
  
// Clock
  timeStr = nf(hh,2)+":"+nf(mm,2)+":"+nf(ss,2);

  pushMatrix();
  translate(width-100,100);
  strokeWeight(4);
  fill(0,64,0);
  stroke(0,255,0);
  ellipse(0,0,200,200);
    
  // second
  pushMatrix();
  rotate(radians(ss*(360/60)));
  strokeWeight(1);
  line(0,0,0,-100);
  popMatrix();
  
  // minute
  pushMatrix();
  rotate(radians(mm*(360/60)));
  strokeWeight(3);
  line(0,0,0,-100);
  popMatrix();

  // hour
  pushMatrix();
  rotate(radians(hh*(360/12)));
  strokeWeight(6);
  line(0,0,0,-60);
  popMatrix();
  popMatrix();
// end of Clock
}

	int group=-1;		//	1,...,30
	int[] achieve = new int[Nz];
			// -1: not yet started, 0:running: 1:complete(going to the next),
			//  2:got to the next, 3:off the track, 4:retired
	int[] zone_start = new int[Nz];
	int[] zone_finish = new int[Nz];
	int[] got_to_next = new int[Nz];
	int[] stopInterval1 = new int[Nz];
	int[] stopInterval2 = new int[Nz];

void saveRecords() {
  int ye = year()%100;
  int mo = month();
  int da = day();
  int s = second();
  int m = minute();
  int h = hour();

  String fname = "record"+nf(ye,2)+nf(mo,2)+nf(da,2)+nf(h,2)+nf(m,2)+nf(s,2)+".csv";
  PrintWriter output = createWriter(fname);
  for (int g=0; g<Ngrp; g++) {
  	String str = ""+(g+1)+","+records[g].group;
	for (int i=0; i<Nz; i++) {
		str += ","+records[g].achieve[i];
		str += ","+records[g].zone_start[i];
		str += ","+records[g].zone_finish[i];
		str += ","+records[g].got_to_next[i];
		str += ","+records[g].stopInterval1[i];
		str += ","+records[g].stopInterval2[i];
	}
  	output.println(str);
  }
  output.flush();
  output.close();
  isChanged = false;
  saveMessage = fname;
  println(saveMessage);
}

void doLoadRecords() {
	String lines[];
	String[] line;
	int ng;

	isChanged = false;
	lines = loadStrings("records.txt");
	if (lines == null) {
		loadMessage = " File not found.";
		return;
	}
	if (lines.length!=Ngrp) {
		loadMessage = " ill-format 1";
		return;
	}
	for (int g=0; g<Ngrp; g++) {
		line = split(lines[g],",");
		if (line.length != 6*Nz+2) {
			loadMessage = " ill-format 2";
			return;
		}
		ng = int(line[0]);
		records[g].group = int(line[1]);
		for (int i=0; i<Nz; i++) {
			records[g].achieve[i]		= int(line[2+i*6]);
			records[g].zone_start[i]	= int(line[3+i*6]);
			records[g].zone_finish[i]	= int(line[4+i*6]);
			records[g].got_to_next[i]	= int(line[5+i*6]);
			records[g].stopInterval1[i]	= int(line[6+i*6]);
			records[g].stopInterval2[i]	= int(line[7+i*6]);
		}
	}
	grp = 0;
	loadMessage = " load records.txt";
}

void ConfirmLoad() {
  int exitChoice = javax.swing.JOptionPane.showConfirmDialog(frame,
    "Data will be overwritten. Are you sure?", "ZoneTimer - Load Confirmation", javax.swing.JOptionPane.YES_NO_OPTION);
  if (exitChoice == javax.swing.JOptionPane.YES_OPTION) {
    doLoadRecords();
  }
}

void loadRecords() {
	ConfirmLoad();
}

void draw() {	// Main
  int ms = millis();
  background(0,128,0);

  if (grp>=Ngrp) {
    return;
  }

//	1920 x 1080
  textSize(100);
  textAlign(RIGHT);
  fill(0,255,0);
//text(timeStr,width,100);

  textAlign(LEFT);
  text("#"+(grp+1),200,100);
  text("Group "+records[grp].group,480,100);

  fill(0,64,0);
  for (int i=0; i<Nz; i++) {
    textAlign(LEFT);
    int msec,sec,zs;
    int ac = records[grp].getAchieve(i);

    // print Time
    if (ac<0) {		// not yet started
       fill(0,64,0);
    } else if (ac==0) {	// running
       fill(0,255,0);
    } else if (ac==1) {	// complete (going to the next)
       fill(0,192,0);
    } else if (ac==2) {	// got to the next
       fill(0,192,0);
    } else if (ac==3) {	// off the track
       fill(0,0,128);
    } else if (ac==4) {	// retired
       fill(128,0,0);
    }
    if (i==0) {
      text("Total:",200,(i+1)*120+100);
    } else if (i<=3) {
      text("Zone "+i,200,(i+1)*120+100);
    } else if (i==4) {
      text("Speed:",200,(i+1)*120+100);
    } else {
      text("Zone "+(i-1),200,(i+1)*120+100);
    }
    
    textAlign(RIGHT);
    msec = records[grp].getTime1(i,ms);
    sec = msec/1000;
    zs = (msec - sec*1000)/100;
    if (i>0) {
      if (ac==0) {
      	if (sec>=time1) {
          fill(255,0,0);
	} else {
          fill(0,255,0);
	}
      } else if (ac>0) {
      	if (sec>=time1) {
          fill(192,0,0);
	} else {
          fill(0,192,0);
	}
      }
    }
    text(""+sec+"."+zs,1000,(i+1)*120+100);
    if (i>0) {
      msec = records[grp].getTime2(i,ms);
      sec = msec/1000;
      zs = (msec - sec*1000)/100;
      if ((ac>=0)&&(ac<=1)) {	// running or going to the next
        if (sec>=time2) {
          fill(255,0,0);
        } else {
          fill(0,255,0);
        }
      }
      if (ac>1) {		// got to the next
        if (sec>=time2) {
          fill(192,0,0);
        } else {
          fill(0,192,0);
        }
      }
      text(""+sec+"."+zs,1400,(i+1)*120+100);
    }

    // Bell
    if ((i>0)&&(i!=4)) {
      if ((sec==time1)&&(timeBell1<0)&&(ac==0)&&(!isStopCounting)) {
        bell1.play();
        timeBell1 = ms;
      }
      if ((sec==time2)&&(timeBell2<0)&&(ac>=0)&&(ac<=1)&&(!isStopCounting)) {
        bell2.play();
        timeBell2 = ms;
      }
    }
    if (i==0) {
      if ((sec==time3)&&(timeBell3<0)&&(!isStopCounting)) {
        bell3.play();
        timeBell3 = ms;
      }
    }
  }
  if ((timeBell1>0) && (ms-timeBell1>1500)) {
    bell1.close();
    bell1 = minim.loadFile("bell1.wav");
    timeBell1=-1;
  }
  if ((timeBell2>0) && (ms-timeBell2>1500)) {
    bell2.close();
    bell2 = minim.loadFile("bell2.wav");
    timeBell2=-1;
  }
  if ((timeBell3>0) && (ms-timeBell3>2000)) {
    bell3.close();
    bell3 = minim.loadFile("bell3.wav");
    timeBell3=-1;
  }
  drawClock();
  secondFrame.redraw();
  thirdFrame.redraw();
}

void keyPressed() {	// Main
  if (key == ENTER) {
  	if (grp<Ngrp) {
		if (records[grp].getAchieve(0)>0) {
			grp++;
		} else {
  			records[grp].returnPressed();
		}
	}
  } else if (key == ESC) {
    key = 0;
    exit();
  } else if (key == 's') {
    secondFrame.close();
    secondFrame = new ControlFrame(this);
  }
}
